package com.example.hellojsf.dto;

import jakarta.validation.constraints.Min;
import jakarta.validation.constraints.Size;
import lombok.*;

import java.util.UUID;

@NoArgsConstructor
@RequiredArgsConstructor
@ToString()
@EqualsAndHashCode(onlyExplicitlyIncluded = true)
public class Person implements Cloneable{

    @Getter @Setter @EqualsAndHashCode.Include
    private UUID id;

    @Getter @Setter @NonNull
    private String login;
//    @Size(min=3)

    @Getter @Setter @NonNull @ToString.Exclude
    private String password;

    @Getter @Setter @NonNull
    private String email;

    @Getter @Setter @NonNull
    private int age;

    @Getter @Setter @NonNull
    private boolean active;

    @Override
    public Person clone() {
        try {
            return (Person) super.clone();
        } catch (CloneNotSupportedException e) {
            return new Person();
        }
    }
}
