package com.example.hellojsf.mock;

import com.example.hellojsf.dto.Person;
import jakarta.enterprise.context.ApplicationScoped;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.UUID;

// This class serves as "whole backend stuff" mock
@ApplicationScoped
public class PersonStore {

    public PersonStore() {
        for (int i = 1; i <= 5; i++) {
            addPerson(new Person(
                    "login"+String.valueOf(i),
                    "pwd"+String.valueOf(i),
                    "person"+String.valueOf(i)+"@spjava.com",
                    13*i,
                    (i%2==0)
            ));
        }
    }

    private final Map<UUID, Person> persons = new HashMap<>();

    public List<Person> getAllPersons() {
        System.out.println("GET ALL PERSONS");return persons.values().stream().toList();
    }

    public void addPerson(Person person) {
        person.setId(UUID.randomUUID());
        persons.put(person.getId(),person);
    }

    public Person getPerson(UUID id) {
        return persons.get(id).clone();
    }

    public void removePerson(UUID id) {
        persons.remove(id);
    }

    public void updatePerson(UUID id, Person source) {
        Person personToUpdate = persons.get(id);
        if(null == personToUpdate) throw new IllegalArgumentException("Person not found");
        personToUpdate.setEmail(source.getEmail());
        personToUpdate.setAge(source.getAge());
    }

    public void activatePerson(UUID id) {
        setActivePerson(id, true);
    }

    public void deactivatePerson(UUID id) {
        setActivePerson(id, false);
    }

    private void setActivePerson(UUID id, boolean value) {
        Person personToUpdate = persons.get(id);
        if(null == personToUpdate) throw new IllegalArgumentException("Person not found");
        personToUpdate.setActive(value);
    }
}

