package com.example.hellojsf.web;

import com.example.hellojsf.dto.Person;
import com.example.hellojsf.mock.PersonStore;
import jakarta.enterprise.context.Conversation;
import jakarta.enterprise.context.ConversationScoped;
import jakarta.enterprise.context.RequestScoped;
import jakarta.enterprise.context.SessionScoped;
import jakarta.inject.Inject;
import jakarta.inject.Named;

import java.io.Serializable;
import java.util.UUID;

@Named
@ConversationScoped
public class UpdatePersonBean implements Serializable {
    @Inject
    private PersonStore personStore;

    @Inject
    private Conversation conversation;

    private Person updatePerson;

    public void init(UUID personToBeUpdated) {
        if(!conversation.isTransient()) {
            conversation.end();
        }
        conversation.begin();
        updatePerson = personStore.getPerson(personToBeUpdated);
    }

    public Person getUpdatePerson() {
        return updatePerson;
    }

    public String doUpdatePerson() {
        personStore.updatePerson(updatePerson.getId(), updatePerson);
        conversation.end();
        return "listPersons";
    }
}
